import time
import sys
import math
#
#
from System.Collections.Generic import List
from System import Byte, Int32
#
def FindMobilesOnGround(itemIdList, range=2):
    item = None 
    findItem = Items.Filter()
    findItem.Enabled = True
    findItem.RangeMax = range
    findItem.Graphics = List[int](itemIdList)
    findItem.OnGround = True
    findItem.Movable = False
    listItem = Items.ApplyFilter(findItem)    
    return listItem
#
def YarnToCloth():
    yarns = findRecursive(Player.Backpack.Serial, [0x0E1D,0x0FA0 ])
    while yarns:
        Items.UseItem(yarns[0])
        Target.WaitForTarget(1000, False)   
        Target.TargetExecute(Loom[0])
        Misc.Pause(500)
        yarns = findRecursive(Player.Backpack.Serial, [0x0E1D,0x0FA0 ])
        if Player.Weight > (Player.MaxWeight*0.9) or Player.Weight > 500:
            bolts = Items.FindByID(0x0F95, -1, Player.Backpack.Serial)
            if bolts:
                Items.Move(bolts.Serial, Misc.ReadSharedValue("BagOfHolding"), 0)
#
#0x2E3F 0x101C
SpinningWheels = FindMobilesOnGround([0x101C, 0x2E3F], 4)
if not SpinningWheels:
    Misc.SendMessage("Must be near spinning wheel")
    sys.exit(4)
Loom = FindMobilesOnGround([0x1062, 0x1060], 4)
if Loom == None:
    Misc.SendMessage("Must be near Loom")
    sys.exit(4)

def findRecursive(containerSerial, typeArray):
    ret_list = []
    container = Items.FindBySerial(containerSerial)
    if container != None:
        for item in container.Contains:
            if item.ItemID in typeArray:
                ret_list.append(item)
            if item.IsContainer:
                for tmp in findRecursive(item.Serial, typeArray):
                    ret_list.append(tmp)
    return ret_list
#    
YarnToCloth()
#
end_time = time.time()
wools = findRecursive(Player.Backpack.Serial, [0x0DF8, 0xDF9, 0x1A9C, 0x1A9D])
Misc.SendMessage(len(wools))
if wools != None and len(wools) > 0:
    for wool in wools:
        for X in range(wool.Amount/len(SpinningWheels)): 
            calc_wait =  end_time - time.time()
            #Misc.SendMessage("Misc.Pause: {}".format(calc_wait))
            if calc_wait > 0:
                Misc.SendMessage("Misc.Pause: {}".format(calc_wait))
                Misc.Pause((int)(calc_wait*1000))
            end_time = time.time() + 3.5    
            for wheel in SpinningWheels:
                Items.UseItem(wool)
                Target.WaitForTarget(1000, False)
                Target.TargetExecute(wheel)
            #
            yarn = findRecursive(Player.Backpack.Serial, [0x0E1D,0x0FA0 ])            
            while yarn:
                YarnToCloth()
                yarn = findRecursive(Player.Backpack.Serial, [0x0E1D,0x0FA0 ])    
#        
calc_wait =  end_time - time.time()
if calc_wait > 0:
    Misc.Pause(calc_wait)
Misc.Pause(5000)
YarnToCloth()
Misc.Disconnect()

